import django_filters as filters
from django_filters import CharFilter#, DateFilter
from .models import Course, CourseRegistration, Invoice, Programme, Spreadsheet
# from django.forms.widgets import TextInput

class CourseAcademicFilter(filters.FilterSet):
    course = CharFilter(field_name='course_code', lookup_expr='icontains', label="Course Code")
    class Meta:
        model = Course
        fields = []

class CourseUnderGradFilter(filters.FilterSet):
    class Meta:
        model = Course
        fields = ['department__faculty', 'department']
    def __init__(self, *args, **kwargs):
        super(CourseUnderGradFilter, self).__init__(*args, **kwargs)
        self.filters['department__faculty'].label="Faculty"
        # self.filters['programme__department'].label="Department"

class CourseRegisteredUnderGradFilter(filters.FilterSet):
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course Code")
    # undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric Number")
    class Meta:
        model = CourseRegistration
        fields = []
    # def __init__(self, *args, **kwargs):
    #     super(RegisteredCourseUnderGradFilter, self).__init__(*args, **kwargs)
    #     self.filters['course__course_code'].label="Course Code"
    #     self.filters['undergrad__username'].label="Matric Number"

class CourseRegisteredAcademicFilter(filters.FilterSet):
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course Code")
    undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric Number")
    class Meta:
        model = CourseRegistration
        fields = []
    # def __init__(self, *args, **kwargs):
    #     super(RegisteredCourseUnderGradFilter, self).__init__(*args, **kwargs)
    #     self.filters['course__course_code'].label="Course Code"
    #     self.filters['undergrad__username'].label="Matric Number"

class InvoiceAdminFilter(filters.FilterSet):
    undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric Number")
    class Meta:
        model = Invoice
        fields = []
    # def __init__(self, *args, **kwargs):
    #     super(RegisteredCourseUnderGradFilter, self).__init__(*args, **kwargs)
    #     self.filters['course__course_code'].label="Course Code"
    #     self.filters['undergrad__username'].label="Matric Number"

class ProgrammeFilter(filters.FilterSet):
    session = CharFilter(field_name='session__session', lookup_expr='icontains', label="Session")
    semester = CharFilter(field_name='semester__semester', lookup_expr='icontains', label="Semester")
    level = CharFilter(field_name='level__level', lookup_expr='icontains', label="Level")
    programme = CharFilter(field_name='programme__programme', lookup_expr='icontains', label="Programme")

    class Meta:
        model = Spreadsheet
        fields = []
